<script setup lang="ts">
import { useWorkspaceStore } from "@/stores/useWorkspaceStore";
import { ref } from "vue";
import { useI18n } from "vue-i18n";
import { useTheme } from "vuetify";

definePageMeta({ layout: "welcome" });

const workspaceStore = useWorkspaceStore();

const form = ref(null);
const workspace = ref("");

const t = useI18n();
const theme = useTheme();

const config = useRuntimeConfig();
const appID = config.public.oidcClientID;

useAPIFetch(`/api/applications/${appID}/userparams`).then((response) => {
  // Theme
  if ("params" in response.data.value && "theme" in response.data.value.params) {
    theme.global.name.value = response.data.value.params.theme;
  }

  // Language
  if ("params" in response.data.value && "language" in response.data.value.params) {
    t.locale.value = response.data.value.params.language;
  }
});

async function newWorkspace() {
  const test = await form.value.validate();
  if (test.valid) {
    const WorkspaceObjet = await workspaceStore.createWorkspace(workspace.value, "");
    await navigateTo(`/${WorkspaceObjet.slug}`);
  }
}
</script>

<template>
  <v-container class="d-flex align-center fill-height">
    <div>
      <h1>Welcome to Madbot</h1>
      <p class="mb-4">
        {{ $t("welcome_text_1") }}
      </p>
      <p class="mb-4">
        {{ $t("welcome_text_2") }}<br>
        {{ $t("welcome_text_3") }}
      </p>

      <v-form ref="form">
        <v-text-field
          v-model="workspace"
          :label="$t('workspace_name')"
          variant="solo"
          autofocus
          :rules="[(v) => !!v || $t('workspace_name_required')]"
          @keydown.enter.prevent="newWorkspace"
        />
        <v-btn
          color="primary"
          class="mt-2"
          @click="newWorkspace()"
        >
          Start
        </v-btn>
      </v-form>
    </div>
  </v-container>
</template>
